package net.meutel.swarm.etcd.runtime;

import net.meutel.swarm.etcd.EtcdTopologyFraction;
import org.jboss.msc.service.ServiceActivator;
import org.jboss.msc.service.ServiceActivatorContext;
import org.jboss.msc.service.ServiceRegistryException;
import org.jboss.msc.service.ServiceTarget;
import org.wildfly.swarm.topology.runtime.TopologyManager;
import org.wildfly.swarm.topology.runtime.TopologyManagerActivator;

import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.inject.Any;
import javax.inject.Inject;

/**
 * EtcdClient MSC activator.
 */
@ApplicationScoped
public class EtcdClientActivator implements ServiceActivator {

    @Inject
    @Any
    EtcdTopologyFraction fraction;

    public void activate(ServiceActivatorContext context) throws ServiceRegistryException {
        System.out.println("Activate Etcd client");
        ServiceTarget target = context.getServiceTarget();
        EtcdClient client = new EtcdClient(fraction.url());
        target.addService(EtcdClient.SERVICE_NAME, client)
                .install();
    }
}
