package net.meutel.swarm.etcd.runtime;

import org.jboss.msc.service.*;
import org.wildfly.swarm.topology.runtime.TopologyManager;
import org.wildfly.swarm.topology.runtime.TopologyManagerActivator;

import javax.enterprise.context.ApplicationScoped;

/**
 * Etcd Topology MSC activator.
 */
@ApplicationScoped
public class EtcdTopologyConnectorActivator implements ServiceActivator {

    public void activate(ServiceActivatorContext context) throws ServiceRegistryException {
        System.out.println("Activate Etcd topology");
        ServiceTarget target = context.getServiceTarget();

        EtcdTopologyConnector connector = new EtcdTopologyConnector();

        target.addService(TopologyManagerActivator.CONNECTOR_SERVICE_NAME, connector)
            .addDependency(TopologyManagerActivator.SERVICE_NAME, TopologyManager.class, connector.getTopologyManagerInjector())
            .addDependency(EtcdClient.SERVICE_NAME, EtcdClient.class, connector.getClientInjector())
            .install();
    }
}
